// Vytvorenie dokumentu s výpočtom sadzobného obrazca a okrajov
// (c) JP, verzia 2015.01.10

//Definícia globálnych nastavení
//Prednastavené hodnoty musia byť v pt, nech je vstup v akejkoľvek jednotke (pt, mm,...)
//Štandardné hodnoty: A5, spadávka 3mm, popis 0mm, pomer okrajov 1:1:fí:fí, pomer sadzobného obrazca 1:fí
var gSirkaW=419.527559055118; //148 mm
var gVyskaH=595.275590551181; //210 mm
var gSpadavka=8.50393700787402; //3 mm
var gPopis=0; //0 mm
var gVnutorne=0; //0 mm
var gOL=1;
var gOR=1.6180339887499;
var gOT=1;
var gOB=1.6180339887499;
var gX=1;
var gY=1.6180339887499;
var gObrazecW=284.366288416515; //cca 100,318 mm
var gObrazecH=460.114319912578; //cca 162,318 mm

var gPomer=0;
var gStlpcePocet=1;
var gStlpceOdsadenie=0;

var gOkrajL;
var gOkrajR;
var gOkrajT;
var gOkrajB;
var NovyDokument;

ZobrazDialog();

function ZobrazDialog(){
 //Načítame nastavenia zo súboru (ak existuje)
 Nacitaj_nastavenia();
 // Odpamätáme si terajšie nastavenie bodov na palec, napr. 67.564 (Didot)
 var BodyNaPalec=app.viewPreferences.pointsPerInch;
 var DialogParametre = app.dialogs.add({name:"Vytvorenie dokumentu s výpočtom obrazca a okrajov"});
 with(DialogParametre){
  with(dialogColumns.add()){
   with (dialogRows.add()) {
    with(dialogColumns.add()){
     with(borderPanels.add()){
      with(dialogColumns.add()){      
       staticTexts.add({staticLabel:"Strana dokumentu"});
       staticTexts.add({staticLabel:"Šírka:"});
       staticTexts.add({staticLabel:"Výška:"});
       staticTexts.add({staticLabel:"Spadávka:"});
       staticTexts.add({staticLabel:"Popis:"});      
       staticTexts.add({staticLabel:"Pomery (\u03C6=1,618033988749, \u221A(2)=1,414213562373)"});
       staticTexts.add({staticLabel:"Okraje (vnútorný : horný : vonkajší : spodný)"});
       staticTexts.add({staticLabel:"Sadzobný obrazec"});
       staticTexts.add({staticLabel:"Pomer (šírka : výška)"});
       staticTexts.add({staticLabel:"Priamy rozmer (šírka, výška)"});
       staticTexts.add({staticLabel:"Posunutie sadzobného obrazca voči vnútornému okraju:"});
      }
      with(dialogColumns.add()){
       staticTexts.add({staticLabel:" "}); //Strana dokumentu
       var SirkaWField = measurementEditboxes.add({editValue:gSirkaW, editUnits:MeasurementUnits.MILLIMETERS});
       var VyskaHField = measurementEditboxes.add({editValue:gVyskaH, editUnits:MeasurementUnits.MILLIMETERS});
       var SpadavkaField = measurementEditboxes.add({editValue:gSpadavka, editUnits:MeasurementUnits.MILLIMETERS});     
       var PopisField = measurementEditboxes.add({editValue:gPopis, editUnits:MeasurementUnits.MILLIMETERS});
       staticTexts.add({staticLabel:" "});
       var OLField = realEditboxes.add({editValue:gOL});
       staticTexts.add({staticLabel:" "});       
       var MoznostiObrazca = radiobuttonGroups.add();
       with(MoznostiObrazca){
        radiobuttonControls.add({staticLabel:" ", checkedState:(gPomer==0)});
        radiobuttonControls.add({staticLabel:" ", checkedState:(gPomer==1)});
       }
       var VnutorneField = measurementEditboxes.add({editValue:gVnutorne, editUnits:MeasurementUnits.MILLIMETERS});
      }
      with(dialogColumns.add()){
       staticTexts.add({staticLabel:" "}); //Strana dokumentu
       staticTexts.add({staticLabel:" "}); //Šírka
       staticTexts.add({staticLabel:" "}); //Výška
       staticTexts.add({staticLabel:" "}); //Spadávka    
       staticTexts.add({staticLabel:" "}); //Popis
       staticTexts.add({staticLabel:" "}); //Pomery
       staticTexts.add({staticLabel:":"}); //Okraje
      }
      with(dialogColumns.add()){
       staticTexts.add({staticLabel:" "}); //Strana dokumentu
       staticTexts.add({staticLabel:" "}); //Šírka
       staticTexts.add({staticLabel:" "}); //Výška
       staticTexts.add({staticLabel:" "}); //Spadávka    
       staticTexts.add({staticLabel:" "}); //Popis
       staticTexts.add({staticLabel:" "}); //Pomery
       var OTField = realEditboxes.add({editValue:gOT});
       staticTexts.add({staticLabel:" "}); //Sadzobný obrazec
       var XField = realEditboxes.add({editValue:gX});
       var ObrazecXField = measurementEditboxes.add({editValue:gObrazecW, editUnits:MeasurementUnits.MILLIMETERS});      
      }
      with(dialogColumns.add()){
       staticTexts.add({staticLabel:" "}); //Strana dokumentu
       staticTexts.add({staticLabel:" "}); //Šírka
       staticTexts.add({staticLabel:" "}); //Výška
       staticTexts.add({staticLabel:" "}); //Spadávka    
       staticTexts.add({staticLabel:" "}); //Popis
       staticTexts.add({staticLabel:" "}); //Pomery
       staticTexts.add({staticLabel:":"}); //Okraje
       staticTexts.add({staticLabel:" "}); //Sadzobný obrazec
       staticTexts.add({staticLabel:":"}); //Pomer
       staticTexts.add({staticLabel:","}); //Priamy rozmer
      }
      with(dialogColumns.add()){
       staticTexts.add({staticLabel:" "}); //Strana dokumentu
       staticTexts.add({staticLabel:" "}); //Šírka
       staticTexts.add({staticLabel:" "}); //Výška
       staticTexts.add({staticLabel:" "}); //Spadávka    
       staticTexts.add({staticLabel:" "}); //Popis
       staticTexts.add({staticLabel:" "}); //Pomery
       var ORField = realEditboxes.add({editValue:gOR});
       staticTexts.add({staticLabel:" "}); //Sadzobný obrazec
       var YField = realEditboxes.add({editValue:gY});
       var ObrazecYField = measurementEditboxes.add({editValue:gObrazecH, editUnits:MeasurementUnits.MILLIMETERS});
      } 
      with(dialogColumns.add()){
       staticTexts.add({staticLabel:" "}); //Strana dokumentu
       staticTexts.add({staticLabel:" "}); //Šírka
       staticTexts.add({staticLabel:" "}); //Výška
       staticTexts.add({staticLabel:" "}); //Spadávka    
       staticTexts.add({staticLabel:" "}); //Popis
       staticTexts.add({staticLabel:" "}); //Pomery
       staticTexts.add({staticLabel:":"}); //Okraje
      }
      with(dialogColumns.add()){
       staticTexts.add({staticLabel:" "}); //Strana dokumentu
       staticTexts.add({staticLabel:" "}); //Šírka
       staticTexts.add({staticLabel:" "}); //Výška
       staticTexts.add({staticLabel:" "}); //Spadávka    
       staticTexts.add({staticLabel:" "}); //Popis
       staticTexts.add({staticLabel:" "}); //Pomery
       var OBField = realEditboxes.add({editValue:gOB});
      }
     }
    }   
   }   
  }
 }
 var Koniec=false;
 do{
  // nastavíme interný počet 72 bodov na palec
  try {
   app.viewPreferences.pointsPerInch=72;
   app.activeDocument.viewPreferences.pointsPerInch=72;
  }
  catch (e) {}
  var DialogParametreOK = DialogParametre.show();
  // Nastavíme pôvodný počet bodov na palec
  try {
   app.viewPreferences.pointsPerInch=BodyNaPalec;
   app.activeDocument.viewPreferences.pointsPerInch=BodyNaPalec;
  }
  catch (e) {}
  if (DialogParametreOK == true){
   //Nastavenie premenných z dialógu
   gSirkaW=SirkaWField.editValue;
   gVyskaH=VyskaHField.editValue;
   gSpadavka=SpadavkaField.editValue;
   gPopis=PopisField.editValue;
   gVnutorne=VnutorneField.editValue;
   gOL=OLField.editValue;;
   gOR=ORField.editValue;
   gOT=OTField.editValue;
   gOB=OBField.editValue;
   gPomer=MoznostiObrazca.selectedButton;
   gX=XField.editValue;
   gY=YField.editValue;
   gObrazecW=ObrazecXField.editValue;
   gObrazecH=ObrazecYField.editValue;
   var Chyba=false;
   var AkaChyba="";
   pomX=gSirkaW-gVnutorne; //Posun sa použije pri výpočte
   var oo=0;
   Chyba=((pomX<=0) || (gVyskaH <= 0) || (gSirkaW <= 0));
   Chyba=(Chyba || (gOL < 0) || (gOR < 0) || (gOT < 0) || (gOB < 0));
   Chyba=(Chyba || (gX <= 0) || (gY <= 0));
   if (Chyba==true) {AkaChyba="\nNulové alebo záporné vstupné hodnoty!";}
   else {  
    if (gPomer==0) {
     //Máme pomer obrazca, musíme vypočítať jeho veľkosť a veľkosť okrajov 
     var citatel=(gY*pomX)-(gX*gVyskaH);
     var menovatel=gY*(gOL+gOR)-gX*(gOT+gOB);
     var oo=0;
     if (menovatel == 0) {
      Chyba=true;
      AkaChyba=AkaChyba+"\nNie je možné vypočítať okraje (delenie nulou)!";
     }
     else {
      oo=citatel/menovatel;
     }
     if (oo<0) {
      Chyba=true;
      AkaChyba=AkaChyba+"\nZáporné okraje!";
     }
     gOkrajL=oo*gOL+gVnutorne;
     gOkrajR=oo*gOR;
     gOkrajT=oo*gOT;
     gOkrajB=oo*gOB;
     gObrazecW=gSirkaW-(gOkrajL+gOkrajR);
     gObrazecH=gVyskaH-(gOkrajT+gOkrajB);
     if ((gObrazecW<=0) || (gObrazecH<=0)) {
      Chyba=true;
      AkaChyba=AkaChyba+"\nNulová alebo záporná veľkosť sadzobného obrazca!";
     } 
    }
    else {
     //Máme rozmer obrazca, musíme vypočítať jeho pomer a veľkosť okrajov
     if ((gObrazecW<=0) || (gObrazecH<=0)) {
      Chyba=true;
      AkaChyba=AkaChyba+"\nNulový alebo záporný rozmer sadzobného obrazca!";
     }
     else {
      if ((gObrazecW>pomX) || (gObrazecH>gVyskaH)) {
       Chyba=true;
       AkaChyba=AkaChyba+"\nSadzobný obrazec väčší ako strana!";
      }
      else {
       gX=1;
       gY=gObrazecH/gObrazecW;
       var oo=pomX-gObrazecW;
       var oos=gOL+gOR;
       if ((oos==0) && (oo!=0)) {
        Chyba=true;
        AkaChyba=AkaChyba+"\nNie je možné vypočítať vnútorný a vonkajší okraj!";
       }
       else {
        gOkrajL=oo*(gOL/oos)+gVnutorne;
        gOkrajR=gSirkaW-gObrazecW-gOkrajL;
        if (gOkrajR<0) {
         Chyba=true;
         AkaChyba=AkaChyba+"\nZáporný vonkajší okraj!";
        }
       }
       oo=gVyskaH-gObrazecH;
       oos=gOT+gOB;
       if ((oos==0) && (oo!=0)) {
        Chyba=true;
        AkaChyba=AkaChyba+"\nNie je možné vypočítať horný a spodný okraj!";
       }
       else {
        gOkrajT=oo*(gOT/oos);
        gOkrajB=oo-gOkrajT;
        if (gOkrajB<0) {
         Chyba=true;
         AkaChyba=AkaChyba+"\nZáporný spodný okraj!";
        }
       }
      }
     }
    }
   }
   if (Chyba==false) {
    if (ZobrazStlpce(BodyNaPalec)==true) {    
     Uloz_nastavenia();
     VytvorDokument();
     Koniec=true;
    }
   }
   else {
    alert("Dokument so zadanými parametrami nie je možné vytvoriť!"+AkaChyba);
   }
  }
  else{
   Koniec=true;
  }
 } while(Koniec == false);
 DialogParametre.destroy();
}

function ZobrazStlpce(BodyNaPalec) {
 var Prepocet=25.4/72; 
 var lSirkaW=gSirkaW*Prepocet;
 var lVyskaH=gVyskaH*Prepocet;
 var lObrazecW=gObrazecW*Prepocet;
 var lObrazecH=gObrazecH*Prepocet;
 var Percento=100*(gObrazecW*gObrazecH)/(gSirkaW*gVyskaH);
 var lVnutorne=gVnutorne*Prepocet; 
 var lOkrajL=gOkrajL*Prepocet;
 var lOkrajR=gOkrajR*Prepocet;
 var lOkrajT=gOkrajT*Prepocet;
 var lOkrajB=gOkrajB*Prepocet;
 // nastavíme interný počet 72 bodov na palec
 try {
  app.viewPreferences.pointsPerInch=72;
  app.activeDocument.viewPreferences.pointsPerInch=72;
 }
 catch (e) {}
 var DialogStlpce = app.dialogs.add({name:"Definícia stĺpcov"});
 with(DialogStlpce){
  with(dialogColumns.add()){
   with (dialogRows.add()) {
    with(dialogColumns.add()){
     with(borderPanels.add()){
      with(dialogColumns.add()){
       staticTexts.add({staticLabel:"Strana dokumentu"});
       staticTexts.add({staticLabel:"Sadzobný obrazec"});
       staticTexts.add({staticLabel:"Využitie plochy strany"}); 
       staticTexts.add({staticLabel:"Ľavý; pravý okraj"});
       staticTexts.add({staticLabel:"Horný; spodný okraj"});
       staticTexts.add({staticLabel:"Počet stĺpcov:"});
       staticTexts.add({staticLabel:"Odsadenie stĺpcov:"});
      }
      with(dialogColumns.add()){
       staticTexts.add({staticLabel:lSirkaW+" ×"});
       staticTexts.add({staticLabel:lObrazecW+" ×"});
       staticTexts.add({staticLabel:Percento+" %"});
       staticTexts.add({staticLabel:lOkrajL+" ;"});
       staticTexts.add({staticLabel:lOkrajT+" ;"});
       var StlpcePocetField = integerEditboxes.add({editValue:gStlpcePocet});
       var StlpceOdsadenie = measurementEditboxes.add({editValue:gStlpceOdsadenie, editUnits:MeasurementUnits.MILLIMETERS});
      }
      with(dialogColumns.add()){
       staticTexts.add({staticLabel:lVyskaH+" mm"});
       staticTexts.add({staticLabel:lObrazecH+" mm"});
       staticTexts.add({staticLabel:" "});
       staticTexts.add({staticLabel:lOkrajR+" mm"});
       staticTexts.add({staticLabel:lOkrajB+" mm"});
      }
     }
    }   
   }   
  }
 }
 var DialogStlpceOK = DialogStlpce.show();
 gStlpcePocet=StlpcePocetField.editValue;
 gStlpceOdsadenie=StlpceOdsadenie.editValue;
 // Nastavíme pôvodný počet bodov na palec
 try {
  app.viewPreferences.pointsPerInch=BodyNaPalec;
  app.activeDocument.viewPreferences.pointsPerInch=BodyNaPalec;
 }
 catch (e) {}
 if (gStlpcePocet==0) {DialogStlpceOK=false;}
 DialogStlpce.destroy();
 return DialogStlpceOK
}

//Vytvorenie nového dokumentu
function VytvorDokument() {
 // Odpamätáme si terajšie nastavenie bodov na palec, napr. 67.564 (Didot)
 var BodyNaPalec=app.viewPreferences.pointsPerInch;
 // nastavíme interný počet 72 bodov na palec
 try {
  app.viewPreferences.pointsPerInch=72;
  app.activeDocument.viewPreferences.pointsPerInch=72;
 }
 catch (e) {}
 //Odpamätanie pôvodných nastavení pravítok
 var PovodneNastavenia=app.viewPreferences.rulerOrigin;
 var PovodnaXJednotka=app.viewPreferences.horizontalMeasurementUnits;
 var PovodnaYJednotka=app.viewPreferences.verticalMeasurementUnits;
 var PovodnaTahJednotka=app.viewPreferences.strokeMeasurementUnits;
 //Nastavenie pravítok na pt
 app.viewPreferences.rulerOrigin=RulerOrigin.spreadOrigin;
 app.viewPreferences.horizontalMeasurementUnits=MeasurementUnits.POINTS;
 app.viewPreferences.verticalMeasurementUnits=MeasurementUnits.POINTS;
 app.viewPreferences.strokeMeasurementUnits=MeasurementUnits.POINTS;
 //Vytvorenie nového dokumentu
 //Príprava parametrov dokumentu
 var Dokument=app.documentPresets.add();
 with(Dokument) {
  facingPages=true;
  pageHeight=gVyskaH;
  pageWidth=gSirkaW;
  documentBleedUniformSize=true;
  documentBleedTopOffset=gSpadavka;
  documentSlugUniformSize=true;
  slugTopOffset=gPopis;
  columnCount=gStlpcePocet;
  columnGutter=gStlpceOdsadenie;
  bottom=gOkrajB;
  left=gOkrajL;
  right=gOkrajR;
  top=gOkrajT;  
 }
 //Vlastné vytvorenie dokumentu
 NovyDokument=app.documents.add(true,Dokument);
 //Vymazanie prípravy
 Dokument.remove();
 // Nastavíme pôvodné nastavenie bodov na palec, napr. 67.564 (Didot)
 try {
  app.viewPreferences.pointsPerInch=BodyNaPalec;
  NovyDokument.viewPreferences.pointsPerInch=BodyNaPalec;
  app.activeDocument.viewPreferences.pointsPerInch=BodyNaPalec;
 }
 catch (e) {}
 //Nastavíme pôvodné nastavenia pravítok
 app.viewPreferences.rulerOrigin=PovodneNastavenia;
 app.viewPreferences.horizontalMeasurementUnits=PovodnaXJednotka;
 app.viewPreferences.verticalMeasurementUnits=PovodnaYJednotka;
 app.viewPreferences.strokeMeasurementUnits=PovodnaTahJednotka;
 NovyDokument.viewPreferences.horizontalMeasurementUnits=PovodnaXJednotka;
 NovyDokument.viewPreferences.verticalMeasurementUnits=PovodnaYJednotka;
 NovyDokument.viewPreferences.strokeMeasurementUnits=PovodnaTahJednotka;
}

function VyberZoznamDialog(){
 //Načítanie zoznamu zámen
 var kolko=0
 var SuborSkriptu=File(app.activeScript);
 var AdresarSkriptu=SuborSkriptu.parent;
 var NazovSuboru=null; // Ak sa nevyberie súbor, použijú sa nastavenia z programu 
 var ZoznamSuborov=Folder(AdresarSkriptu + "/VytvorDokument/").getFiles("*.txt") // Všetky txt súbory z adresára
 kolko=ZoznamSuborov.length;
 if (kolko>0){
  var ZoznamNazvov = new Array;
  for( var i=0; i<kolko; i++ ) {
   ZoznamNazvov.push(ZoznamSuborov[i].name );
  }
  var myObject;
  var myDialog = app.dialogs.add({name:"Výber nastavení dokumentu"});
  with(myDialog.dialogColumns.add()){
   if (kolko>0) {
    with(dialogRows.add()){
     with(dialogColumns.add()){
      staticTexts.add({staticLabel:"Vyberte nastavenia:"});
     }
     with(dialogColumns.add()){
      var ZoznamDropdown=dropdowns.add({stringList:ZoznamNazvov, selectedIndex:0});
     }
    }
   }
  }
  var myResult = myDialog.show(); 
  if(myResult == true){  
   NazovSuboru=AdresarSkriptu + "/VytvorDokument/" + ZoznamNazvov[ZoznamDropdown.selectedIndex];
  }
  myDialog.destroy();
 }
 return(NazovSuboru);
}

function Nacitaj_nastavenia(){
 //Načítanie nastavení zo súboru
 var Subor=File(VyberZoznamDialog());
 var OtvorenySubor=Subor.open("r", undefined, undefined);
 if (OtvorenySubor) {
  var PoleNastaveni=Subor.read();
  PoleNastaveni=PoleNastaveni.split("\n");
  if (PoleNastaveni.length == 17) {
   gVyskaH=+(PoleNastaveni[0] + "");
   gSirkaW=+(PoleNastaveni[1] + "");
   gSpadavka=+(PoleNastaveni[2] + "");
   gPopis=+(PoleNastaveni[3] + "");
   gVnutorne=+(PoleNastaveni[4] + "");
   gOL=+(PoleNastaveni[5] + "");
   gOR=+(PoleNastaveni[6] + "");
   gOT=+(PoleNastaveni[7] + "");
   gOB=+(PoleNastaveni[8] + "");
   gX=+(PoleNastaveni[9] + "");
   gY=+(PoleNastaveni[10] + "");
   gStlpcePocet=+(PoleNastaveni[11] + "");
   gStlpceOdsadenie=+(PoleNastaveni[12] + "");
   gObrazecW=+(PoleNastaveni[13] + "");
   gObrazecH=+(PoleNastaveni[14] + "");
   gPomer=+(PoleNastaveni[15] + "");        
  }
 }
 Subor.close();
}

function Uloz_nastavenia(){
 //Uloženie posledných nastavení do súboru
 var SuborSkriptu=File(app.activeScript);
 var AdresarSkriptu=SuborSkriptu.parent;
 var NazovSuboru=AdresarSkriptu + "/VytvorDokument/" + "VytvorDokument_nastavenia.txt";
 var Subor=File(NazovSuboru);
 var OtvorenySubor=Subor.open("w", undefined, undefined);
 if (OtvorenySubor) {
  Subor.writeln(gVyskaH);
  Subor.writeln(gSirkaW);
  Subor.writeln(gSpadavka);
  Subor.writeln(gPopis);
  Subor.writeln(gVnutorne);
  Subor.writeln(gOL);
  Subor.writeln(gOR);
  Subor.writeln(gOT);
  Subor.writeln(gOB);
  Subor.writeln(gX);
  Subor.writeln(gY);
  Subor.writeln(gStlpcePocet);
  Subor.writeln(gStlpceOdsadenie);
  Subor.writeln(gObrazecW);
  Subor.writeln(gObrazecH);
  Subor.writeln(gPomer);
 }
 Subor.close();
}
